
/**********************************************************

  File Name : lu.c
  Function  : make the procgroup file in appropriate directory,
              and run LU decompistion.

  Input arg : 
              arg1 : machine type
	      ( 1 = SUN Solaris,  2 = IBM RS/6000, 3 = PC Linux )
	      arg2 : no. of nodes

***********************************************************/

/**************************************
  This Program is temporay.
  Only Good in nova.npac.syr.edu.

  Directory is
  /tmp_mnt/home/A10E/kimd/VDCE/Program/Starter
***************************************/

#include <stdlib.h>
#include <stdio.h>

/* machine type */
#define SUN             "SUN"
#define RS6000          "RS6K"
#define Linux           "LINUX"

/* default directory */
#define DIRECTORY       "/tmp_mnt/home/A10E/kimd/VDCE/Program/Starter/"

/* open status */
#define READ_ONLY	"r"
#define WRITE           "w"

main(argc, argv)
int     argc;
char    *argv[];

{
  int  no_node;
  int  type;
  float dummy;
  char machine_type[100];
  char filename[200];
  char machine_name[50][100]; /* Maximum 20 machines */
  char directory[200];
  char command[200];
  FILE *fd, *fopen(), *fclose();
  int  i;


  if (argc != 3) {
    printf("Usage : lu machine_type(1, 2, 3) #_of_nodes \n");
    exit(1);
  }

  type = atoi(argv[1]);

  if (type == 1)
    strcpy(machine_type, SUN);
  else if (type == 2)
    strcpy(machine_type, RS6000);
  else if (type == 3)
    strcpy(machine_type, Linux);
  else {
    printf("Wrong machine type. \n");
    printf("  machine type 1 : Sun Solaris \n");
    printf("  machine type 2 : IBM RS/6000 \n");
    printf("  machine type 3 : PC Linux \n");
    exit(1);
  }

  sprintf(directory,"%s%s/LU/", DIRECTORY, machine_type);
  sprintf(command, "%sLU", directory);

  no_node = atoi(argv[2]);

  printf("arg1 : %d       arg2 : %d \n", type, no_node);

  sprintf(filename, "all.%s", machine_type);

  fd	= fopen(filename, READ_ONLY);

  /* check if the file exists or not */
  if ( fd == NULL ) {
    printf("The file - %s - does not exist. \n", filename);
    exit(1);
  }
  /* read the machine name from the file */
  for (i = 0 ; i < no_node ; i++ ) {
    fscanf(fd, "%s", machine_name[i]);
    fscanf(fd, "%f", &dummy);
  }
  fclose(fd);

  /* make procgroup file */

  sprintf(filename, "%s/procgroup", directory);
  fd = fopen(filename, WRITE);
  if (fd == NULL) {
    printf("couldn't open file\n");
    exit(5);
  }

  fprintf(fd, "local 0 \n");

  for ( i = 0 ; i < no_node ; i++ ) {
    fprintf(fd, "%s  1  %s\n", machine_name[i], command);
  }
  fclose(fd);
}




